# wxStaticBox Class Reference
[Controls]

`#include <wx/statbox.h>`

Inheritance diagram for wxStaticBox:
[legend]

## Detailed Description

A static box is a rectangle drawn around other windows to denote a logical grouping of items.

Note that while the previous versions required that windows appearing inside a static box be created as its siblings (i.e. use the same parent as the static box itself), since wxWidgets 2.9.1 it is also possible to create them as children of wxStaticBox itself and you are actually encouraged to do it like this if compatibility with the previous versions is not important.

So the new recommended way to create static box is:

            void MyFrame::CreateControls()
            {
                wxPanel *panel = new wxPanel(this);
                wxStaticBox *box = new wxStaticBox(panel, wxID_ANY, "StaticBox");

                new wxStaticText(box, wxID_ANY "This window is a child of the staticbox");
                ...
            }

While the compatible -- and now deprecated -- way is

                wxStaticBox *box = new wxStaticBox(panel, wxID_ANY, "StaticBox");

                new wxStaticText(panel, wxID_ANY "This window is a child of the panel");
                ...

Also note that there is a specialized wxSizer class (wxStaticBoxSizer) which can be used as an easier way to pack items into a static box.

##

Library: wxCore

Category: Controls
Appearance:

wxMSW appearance | wxGTK appearance | wxMac appearance

See also:
  wxStaticText, wxStaticBoxSizer

## Public Member Functions
| wxStaticBox ()
| Default constructor.
| wxStaticBox (wxWindow *parent, wxWindowID id, const wxString &label, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxStaticBoxNameStr)
| Constructor, creating and showing a static box.
virtual | ~wxStaticBox ()
| Destructor, destroying the group box.
bool | Create (wxWindow *parent, wxWindowID id, const wxString &label, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxStaticBoxNameStr)
| Creates the static box for two-step construction.

List of all members.

## Constructor & Destructor Documentation

wxStaticBox::wxStaticBox | ( |  | ) |

Default constructor.

wxStaticBox::wxStaticBox | ( | wxWindow * | parent,
|  | wxWindowID | id,
|  | const wxString & | label,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `0`,
|  | const wxString & | name = `wxStaticBoxNameStr` |
| ) |  |  |

Constructor, creating and showing a static box.

Parameters:

  | parent | Parent window. Must not be NULL.
  | id | Window identifier. The value wxID_ANY indicates a default value.
  | label | Text to be displayed in the static box, the empty string for no label.
  | pos | Window position. If wxDefaultPosition is specified then a default position is chosen.
  | size | Checkbox size. If wxDefaultSize is specified then a default size is chosen.
  | style | Window style. See wxStaticBox.
  | name | Window name.

See also:
  Create()

virtual wxStaticBox::~wxStaticBox | ( |  | ) | `[virtual]`

Destructor, destroying the group box.

## Member Function Documentation

bool wxStaticBox::Create | ( | wxWindow * | parent,
|  | wxWindowID | id,
|  | const wxString & | label,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `0`,
|  | const wxString & | name = `wxStaticBoxNameStr` |
| ) |  |  |

Creates the static box for two-step construction.

See wxStaticBox() for further details.

|  | [ top ]